Graphics3D 800,600,32,2
	;Graphics3D 1024,768,32,2 ;experimental

SetBuffer BackBuffer()

AppTitle "Kernle 32DLL - BCC 22# - SoS-Submarine - V1.1"

;-------------------------

Type Explosion
	Field Mesh,Counter#
End Type
Global Explosion.Explosion

;-------------------------

Dim Stri$(2)
	Stri(0) = "Thrust: "
	Stri(1) = "Dive:   "
	Stri(2) = "Roll:   "

;-------------------------

Global LevelChoosing,Mode
Dim timex(2,1)
Dim ExplosionTimer(1)
Dim SubControls#(2,6)

;-------------------------
; X,Y
;-------------------------
; X = 0 // Submarine Speed
; X = 1 // Submarine Dive
; X = 2 // Submarine Turn
;
; Y = 0 // SpeedIncrease
; Y = 1 // MaxSpeed
; Y = 2 // WantedSpeed
; Y = 3 // CurrentSpeed
; Y = 4 // Key -> Increase
; Y = 5 // Key -> Decrease
; Y = 6 // Key -> Reset

;Keys
SubControls#(0,4) = 32
SubControls#(0,5) = 30
SubControls#(0,6) = 45
SubControls#(1,4) = 17
SubControls#(1,5) = 31
SubControls#(1,6) = 44
SubControls#(2,4) = 18
SubControls#(2,5) = 16
SubControls#(2,6) = 46

;-------------------------

HUD = LoadImage("HUD.png")

AutoMidHandle 1

Menue = LoadImage("Menue.png")

Counter = LoadImage("C.png")
Counter2 = LoadImage("C2.png")
CounterB = LoadImage("CB.png")
CounterB2 = LoadImage("CB2.png")

Dim CounterC(40,1)

CounterC(20,0) = LoadImage("CC.png")
CounterC(20,1) = LoadImage("CC2.png")
HandleImage CounterC(20,0),-53,9
HandleImage CounterC(20,1),4,1

Print "Proccessing Image Data, Please Wait..." 
TFormFilter 0

For I = -20 To 20
	If I <> 0
		CounterC(20+I,0) = CopyImage(CounterC(20,0))
		RotateImage CounterC(20+I,0),I
		
		CounterC(20+I,1) = CopyImage(CounterC(20,1))
		RotateImage CounterC(20+I,1),I
	EndIf
Next

;-------------------------

Global Player = LoadMesh("Sub.x") ;new
Target = LoadMesh("Sub.x")

EntityAlpha Target,0

Camera = CreateCamera()

;pretty simple lightning
AmbientLight 0,0,0
LightColor CreateLight(2,Player),10,10,10
Light = CreateLight(3,Camera)
LightColor Light,10,10,10

;-------------------------

;just to keep the code small & clean
GH = GraphicsHeight()
GW = GraphicsWidth()

;load all the sounds
GameOverSound = LoadSound("sos-submarine1.mp3")
GameOverSound2 = LoadSound("sos-submarine2.mp3")

BGSound1 = LoadSound("water018.mp3")
LoopSound BGSound1
BGSound2 = LoadSound("ping1.mp3")
LoopSound BGSound2
DamageSound = LoadSound("battle003.mp3")
DamageSound2 = LoadSound("nautical021.mp3")

;-------------------------

If FileType("Highscore.txt") <> 1
	CreateHighscore()
Else
	Stream = ReadFile("Highscore.txt")
	For I = 0 To 2
		timex(I,0) = ReadInt(Stream)
		timex(I,1) = ReadInt(Stream)
	Next
	CloseFile(Stream)
EndIf

;-------------------------

.Restart

For Explosion = Each Explosion
	FreeEntity Explosion\Mesh
	Delete Explosion
Next

;-------------------------

PositionEntity Player,0,0,0
RotateEntity Player,0,0,0
PositionEntity Camera,0,0,-50

;-------------------------

FlushKeys()
BGMusic = PlayMusic("T_BionicCommandoGB_Area2.mid")
StopChannel BGChannel1
StopChannel BGChannel2

;-------------------------

Repeat
	starttime# = MilliSecs()
	TurnEntity Player,0,timemod#,0
	
	RenderWorld
	
	Color 255,255,255
	DrawImage Menue,GW/2,GH/2
	
	If LevelChoosing = 0
		Text GW/2,GH/2,"Map1 (Easy)",1,1
		Text GW/2,GH/2+13,"'Organic Madness'",1,1
	ElseIf LevelChoosing = 1
		Text GW/2,GH/2,"Map2 (Medium)",1,1
		Text GW/2,GH/2+13,"'Deep Escape'",1,1
	Else
		Text GW/2,GH/2,"Map3 (Hard)",1,1
		Text GW/2,GH/2+13,"'Red Devil'",1,1
	EndIf
	
	If Mode = 0
		Text GW/2,GH/2+65,"Discovery Mode",1,1
	ElseIf Mode = 1
		Text GW/2,GH/2+65,"TimeAttack Mode",1,1
	Else
		Text GW/2,GH/2+65,"Expert Mode",1,1
	EndIf
	
	If Mode > 0
		If timex(LevelChoosing,Mode-1) = 40000+10000*(Mode-1)
			Text GW/2,GH/2+78,"No Record Yet",1,1
		Else
			Text GW/2,GH/2+78,"Record: "+GetTimeString$(timex(LevelChoosing,Mode-1)),1,1
		EndIf
	EndIf
	
	Flip 0
	
	endtime# = MilliSecs()
	rendertime# = Abs(endtime#-starttime#)
	timemod = rendertime/10
	
	If endtime# < starttime# Then timemod = 0
	
	If KeyHit(32) Then Mode = Mode + 1
	If KeyHit(30) Then Mode = Mode - 1
	
	If Mode = -1 Then Mode = 2
	If Mode = 3 Then Mode = 0
	
	If KeyHit(31) Then LevelChoosing = LevelChoosing + 1
	If KeyHit(17) Then LevelChoosing = LevelChoosing - 1
	
	If LevelChoosing = -1 Then LevelChoosing = 2
	If LevelChoosing = 3 Then LevelChoosing = 0
	
	If KeyHit(28) Then Exit
	
	If KeyHit(1) Then End
	
	;Debug
	;If KeyHit(2) Then SaveBuffer BackBuffer(),"Screenshoot.bmp"
	;If KeyHit(3) Then VSync = 1-VSync
Forever

If Level Then FreeEntity Level : Level = 0
Level = LoadMesh("L"+LevelChoosing+".x")

Select LevelChoosing
	Case 0
		PositionEntity Target,390,10,0
	Case 1
		PositionEntity Target,350,100,0
	Case 2
		PositionEntity Target,423,93,0
End Select

StopChannel BGMusic
BGChannel1 = PlaySound(BGSound1)
BGChannel2 = PlaySound(BGSound2)

;-------------------------

;Mode0 = Discovery
;Mode1 = TimeAttack
;Mode2 = ExpertMode

;-------------------------

For I = 0 To 2
	SubControls#(I,0) = 0.025
	SubControls#(I,1) = 10.0
	SubControls#(I,2) = 0
	SubControls#(I,3) = 0
Next
SubControls#(2,1) = 8.0

HP# = 100
GameOver = 0
AlphaCounter# = 0
ResetX = 0
ResetY = 0
ResetTurn = 0
CamPos = 1
If Mode = 2 Then CamPos = 0
EntityAlpha Target,1

;-------------------------
;Countdown Part
;-------------------------

timey = MilliSecs()+4000
RotateEntity Player,0,0,0
EntityAlpha Level,1

If Mode < 2
	PositionEntity Camera,EntityX(Target),EntityY(Target),-100
Else
	PositionEntity Camera,EntityX(Player),EntityY(Player),-50
EndIf

Repeat
	starttime# = MilliSecs()
	timey2 = timey-MilliSecs()
	timey3# = timey2
	
	If Mode < 2 And timey2 < 3000 And timey2 > 1000 Then PositionEntity Camera,EntityX(Target)*((timey3-1000)/2000),EntityY(Target)*((timey3-1000)/2000),-CamPos*50-50
	HandleExplosions(1)
	UpdateExplosions(timemod)
	
	RenderWorld
	Text GW/2,GH/2-13,"! GET READY !",1,1
	Text GW/2,GH/2+13,timey2/1000+1,1,1
	
	Flip 0;VSync
	endtime# = MilliSecs()
	rendertime# = Abs(endtime#-starttime#)
	timemod = rendertime/10
	
	If endtime# < starttime# Then timemod = 0
	
	If timey2 <= 0 Then Exit
Forever

;-------------------------

BGMusic = PlayMusic("DKL_-_Flooded_Ruins.mid")
LevelStart = MilliSecs()

FlushKeys()

Repeat
	starttime# = MilliSecs()
	
	;-------------------------
	
	;Movement Control
	Movement = 0
	If GameOver = 0
		For I = 0 To 2
			For I2# = -0.25 To 0.25 Step 0.5
				If I2 = -0.25 Then X = SubControls(I,5) Else X = SubControls(I,4)
				If KeyDown(X) Then SubControls(I,2) = SubControls(I,2) + I2*timemod : Movement = 1
				If KeyHit(SubControls(I,6)) Then SubControls(I,2) = 0
			Next
			
			If Abs(SubControls(I,2)) > Abs(SubControls(I,1)) Then SubControls(I,2) = Sgn(SubControls(I,2))*SubControls(I,1)
			SubControls(I,3) = SubControls(I,3) + Sgn(SubControls(I,2)-SubControls(I,3))*SubControls(I,0)*timemod
			If Abs(SubControls(I,3)) > Abs(SubControls(I,1)) Then SubControls(I,3) = Sgn(SubControls(I,3))*SubControls(I,1)
			
			If Movement = 0 And SubControls(I,3)-SubControls(I,2) < 0.1 And SubControls(I,2)-SubControls(I,3) < 0.1 Then SubControls(I,3) = SubControls(I,2)
		Next
		
		RotateEntity Player,0,0,-SubControls(2,3)/SubControls(2,1)*20
		MoveEntity Player,SubControls#(0,3)/SubControls#(0,1)/4*timemod,SubControls#(1,3)/SubControls#(1,1)/4*timemod,0
		
		If KeyHit(15) And Mode < 2 Then CamPos = CamPos + 1
		If CamPos = 3 Then CamPos = 0
	EndIf
	
	;-------------------------
	
	;Cam Setting
	If MilliSecs() < DamageTimer Then Crash = 1 Else Crash = 0
	If GameOver = 0 Then PositionEntity Camera,EntityX(player,1)+Crash*Rnd(-1,1),EntityY(player,1)+Crash*Rnd(-1,1),-CamPos*50-50
	
	;-------------------------
	
	;Collisions
	If GameOver <> 0
		AlphaCounter = AlphaCounter + 0.01*timemod
		If AlphaCounter > 1.0 Then AlphaCounter = 1.0
		EntityAlpha Level,1.0-AlphaCounter
		
		If GameOver <> 2 ;gameover 2 = win
			PositionEntity Player,EntityX(Player),EntityY(Player)-0.02*timemod,0
			If EntityPitch(Player) > -45 Then TurnEntity Player,-0.05*timemod,0,0.05*timemod
			HandleExplosions(0)
		EndIf
	Else
		If MeshesIntersect(Player,Target)
			GameOver = 2
			NewScore = savehighscore(time)
			PositionEntity Camera,EntityX(player,1),EntityY(player,1),-100
			CamPos = 3
			StopChannel BGMusic
			PlaySound GameOverSound2
			Goto skipcol
		EndIf
		
		If MeshesIntersect(Player,Level)
			If MilliSecs() > DamageTimer
				DamageTimer = MilliSecs()+1000
				TookDamage = 1
				
				PlaySound(DamageSound)
				
				If Mode < 2
					If Mode = 1 Then HP = HP - 20
					If HP > 0 Then PositionEntity Player,ResetX,ResetY,0
					
					For I = 0 To 2
						For I2 = 2 To 3
							SubControls(I,I2) = 0
							If I = 2 Then SubControls(2,I2) = ResetTurn
						Next
					Next
				Else
					HP = 0
				EndIf
			EndIf
		EndIf
		
		If HP <= 0 Then
			HP = 0 : GameOver = 1 : CamPos = 3 : StopChannel BGMusic : PlaySound GameOverSound : PlaySound DamageSound2
			PositionEntity Camera,EntityX(player,1),EntityY(player,1),-100
			StopChannel BGChannel2
		EndIf
	EndIf
	.skipcol
	
	If GameOver <> 2 Then HandleExplosions(1)
	
	;-------------------------
	
	;Timing o.a.
	If ResetTimer < MilliSecs()
		ResetTimer = MilliSecs() + 1000
		ResetX = EntityX(Player,1)
		ResetY = EntityY(Player,1)
		ResetTurn = SubControls(2,3)
	EndIf
	
	Al = 1
	If MilliSecs() < DamageTimer And GameOver = 0 Then Al = Rnd(0,10.0)/10
	EntityAlpha Player,Al
	If GameOver <> 1 Then EntityAlpha Target,Rnd(0,10.0)/10*1 Else EntityAlpha Target,1.0-AlphaCounter
	UpdateExplosions(timemod)
	
	;-------------------------
	
	;Rendering I
	UpdateWorld
	RenderWorld
	
	;-------------------------
	
	;HUD
	If GameOver = 0
		DrawImage HUD,0,GH-ImageHeight(HUD)
		
		DrawImage Counter,11,GH-105-(SubControls(1,2)/SubControls(1,1))*91
		DrawImage Counter2,31,GH-105-(SubControls(1,3)/SubControls(1,1))*91
		
		DrawImage CounterB,142+(SubControls(0,2)/SubControls(0,1))*91,GH-31
		DrawImage CounterB2,142+(SubControls(0,3)/SubControls(0,1))*91,GH-11
		
		DrawImage CounterC(SubControls(2,3)/SubControls(2,1)*20+20,1),50,GH-118
		DrawImage CounterC(SubControls(2,2)/SubControls(2,1)*20+20,0),50,GH-118
		
		;-------------------------
		
		If Mode > 0
			Color 255,255,255
			time = MilliSecs()-LevelStart
			
			Text 0,GH-243,"Time:   "+GetTimeString$(time)
			Text 0,GH-230,"Record: "+GetTimeString$(timex(LevelChoosing,Mode-1))
		EndIf
		
		For I = 0 To 2
			Color 255,255,255
			Percent% = Abs(SubControls(I,3)/Abs(SubControls(I,1))*100)
			Text 140,GH-120+(I+1)*13,Stri(I)+Percent+" %"
			Color GetColorRByPercentage(100-Percent),GetColorGByPercentage(100-Percent),0
			Text 204,GH-120+(I+1)*13,Percent
		Next
		
		Color 255,255,255
		Text 140,GH-120+(I+1)*13,"Damage: "+Int(100.0-HP)+" %"
		Color GetColorRByPercentage(HP),GetColorGByPercentage(HP),0
		Text 204,GH-120+(I+1)*13,Int(100.0-HP)
	Else
		If MilliSecs() > GameOverTimer
			GameOverTimer = MilliSecs()+1000
			GameOverView = 1-GameOverView
		EndIf
		
		Color 255,0,0
		If GameOverView And GameOver = 1 Then Text GW/2,GH/2,"GAME OVER",1,1
		
		Color 0,255,0
		If GameOver = 2
			Text GW/2,GH/2,"! FINISH !",1,1
			
			Color 255,255,255
			If GameOverView
				If NewScore = 1
					Text GW/2,GH/2+13,"NEW RECORD: "+GetTimeString$(time),1,1
				ElseIf NewScore = 2
					Text GW/2,GH/2+13,"DISCOVERY COMPLETE",1,1
				Else
					Text GW/2,GH/2+13,"NO NEW RECORD",1,1
				EndIf
			EndIf
			
			If NewScore = 0
				Text 0,GH-26,"Time:   "+GetTimeString$(time)
				Text 0,GH-13,"Record: "+GetTimeString$(timex(LevelChoosing,Mode-1))
			EndIf
		EndIf
	EndIf
	
	;-------------------------
	
	EntX = EntityX(Player)
	EntY = EntityY(Player)
	
	;Rendering II & rendersync
	Flip 0
	endtime# = MilliSecs()
	rendertime# = Abs(endtime#-starttime#)
	timemod = rendertime/10
	
	If endtime# < starttime# Then timemod = 0
	
	If KeyHit(1) Then HP = 0 FlushKeys()
	
	;Debug
	;If KeyHit(2) Then SaveBuffer BackBuffer(),"Screenshoot.bmp"
	;If KeyHit(3) Then VSync = 1-VSync
	
	If GameOver <> 0 And GetKey() Then EntityAlpha Level,0 : Goto Restart
Forever

Function GetColorRByPercentage(Percent)
	If Percent <= 50 Then Return 255
	Return 255-Float(Percent-50)/100*255*2
End Function

Function GetColorGByPercentage(Percent)
	If Percent <= 50 Then Return Float(Percent)/50*255
	Return 255
End Function

Function SaveHighscore(time)
	If Mode > 0
		If FileType("Highscore.txt") <> 1
			CreateHighscore()
		EndIf
		
		If time < timex(LevelChoosing,Mode-1) Then timex(LevelChoosing,Mode-1) = time : ret = 1
		
		Stream = WriteFile("Highscore.txt")
		For I = 0 To 2
			WriteInt Stream,timex(I,0)
			WriteInt Stream,timex(I,1)
		Next
		CloseFile(Stream)
		
		Return ret
	Else
		Return 2
	EndIf
End Function

Function CreateHighscore()
	Stream = WriteFile("Highscore.txt")
	
	For I = 0 To 2
		timex(I,0) = 40000
		timex(I,1) = 50000
	Next
	
	Stream = WriteFile("Highscore.txt")
	For I = 0 To 2
		WriteInt(Stream,timex(I,0))
		WriteInt(Stream,timex(I,1))
	Next
	
	CloseFile(Stream)
End Function

Function GetTimeString$(time)
	If time > 0
		MSec = time/10
		Sec = time/1000
		Min = Sec/60
			Sec = Sec - Min*60
			Msec = Msec - Sec*100
	EndIf
	
	Return Right("0"+Min,2)+":"+Right("0"+Sec,2)+":"+Right("0"+MSec,2)
End Function

Function HandleExplosions(Kind)
	If Kind = 0
		X = Rnd(-10,10)
		Y = Rnd(-5,5)
		Z = Rnd(-10,5)
	Else
		X = -18+Rnd(-1,1)
		Y = Rnd(-1,1)
		Z = Rnd(-1,1)
	EndIf
	
	If ExplosionTimer(Kind) < MilliSecs()
		ExplosionTimer(Kind) = MilliSecs()+100
		Explosion = New Explosion
		Explosion\Mesh = CreateSphere(8)
		PositionEntity Explosion\Mesh,EntityX(Player),EntityY(Player),EntityZ(Player)
		RotateEntity Explosion\Mesh,EntityPitch(Player),EntityYaw(Player),EntityRoll(Player)
		MoveEntity Explosion\Mesh,X,Y,Z
		EntityColor Explosion\Mesh,0,Rnd(100,255),Rnd(100,255)
		RotateEntity Explosion\Mesh,0,0,0
	EndIf
End Function

Function UpdateExplosions(timemod#)
	For Explosion = Each Explosion
		Sca# = Sin(Explosion\Counter)
		ScaleEntity Explosion\Mesh,Sca,Sca,Sca
		EntityAlpha Explosion\Mesh,Sca*0.4
		MoveEntity Explosion\Mesh,0,0.05*timemod,0
		
		Explosion\Counter = Explosion\Counter + timemod
		
		If Explosion\Counter > 180 Then FreeEntity Explosion\Mesh : Delete Explosion
	Next
End Function